본문 바로가기
알고리즘 문제 풀이/백준

백준 1062 가르침 c++, Kotlin (문자열,조합/DFS)

by 옹구스투스 2021. 7. 11.
반응형

문제 출처 : https://www.acmicpc.net/problem/1062

 

1062번: 가르침

첫째 줄에 단어의 개수 N과 K가 주어진다. N은 50보다 작거나 같은 자연수이고, K는 26보다 작거나 같은 자연수 또는 0이다. 둘째 줄부터 N개의 줄에 남극 언어의 단어가 주어진다. 단어는 영어 소문

www.acmicpc.net

문제

남극에 사는 김지민 선생님은 학생들이 되도록이면 많은 단어를 읽을 수 있도록 하려고 한다. 그러나 지구온난화로 인해 얼음이 녹아서 곧 학교가 무너지기 때문에, 김지민은 K개의 글자를 가르칠 시간 밖에 없다. 김지민이 가르치고 난 후에는, 학생들은 그 K개의 글자로만 이루어진 단어만을 읽을 수 있다. 김지민은 어떤 K개의 글자를 가르쳐야 학생들이 읽을 수 있는 단어의 개수가 최대가 되는지 고민에 빠졌다.

남극언어의 모든 단어는 "anta"로 시작되고, "tica"로 끝난다. 남극언어에 단어는 N개 밖에 없다고 가정한다. 학생들이 읽을 수 있는 단어의 최댓값을 구하는 프로그램을 작성하시오.

입력

첫째 줄에 단어의 개수 N과 K가 주어진다. N은 50보다 작거나 같은 자연수이고, K는 26보다 작거나 같은 자연수 또는 0이다. 둘째 줄부터 N개의 줄에 남극 언어의 단어가 주어진다. 단어는 영어 소문자로만 이루어져 있고, 길이가 8보다 크거나 같고, 15보다 작거나 같다. 모든 단어는 중복되지 않는다.

출력

첫째 줄에 김지민이 K개의 글자를 가르칠 때, 학생들이 읽을 수 있는 단어 개수의 최댓값을 출력한다.

알고리즘 분류

메모리 제한

  • Java 8: 512 MB
  • Java 8 (OpenJDK): 512 MB
  • Java 11: 512 MB
  • Kotlin (JVM): 512 MB

풀이

아마도 내가 24퍼의 정답 비율에 한몫했으리라.

인덱스 하나를 잘못 써서 이유 모를 시간 초과에 골머리를 앓았다.

 

우선 학생들이 배울 수 있는 글자의 수가 k라고 할 때,

모든 단어의 접두사와 접미사로 anta, tica가 주어지므로,

a, n, t, i, c는 필수적으로 배워야 한다.

따라서 k가 5보다 작으면 학생들이 읽을 수 있는 단어는 0개이고,

5보다 크다면, 26개의 알파벳 중, a, n, t, i, c를 제외한 21개의 알파벳을 k-5개 만큼 골라 배워서

가장 많은 단어를 읽을 수 있는 경우를 출력하면 된다.

 

따라서, 풀이의 핵심은 26개의 알파벳 중 k-5개 만큼 배울 글자들을 조합으로 경우의 수를 찾고,

해당 경우의 수들로 글자들을 배웠을 때, 주어진 단어들을 읽을 수 있는지 판단하고, 카운팅하는 것이다.

 

나는 bool ch[26] 배열에, 배운 글자는 true 처리를 해줬고, canRead()함수의 로직을 줄이기 위해, 주어진 단어를

접두사와 접미사를 제거하고, a, n, t, i, c또한 제거한 형태의 단어로 넘겨주었다.

 

set과 map을 이용한 풀이는 조금 그리디하게 짜보려고 했으나, 오히려 시간 초과가 나왔고, 반례에 막혀서 중단했다.

 

코드1(조합/DFS)-통과

#include <iostream>
#include <vector>
#include <string>
#include <cstring>
#include <algorithm>

using namespace std;
bool chk[26];
vector<string> word;
int answer;
int canRead() {//배울 수 있는 단어가 몇 개 되는지
    int cnt = 0;

    for (int i = 0; i < word.size(); i++) {

        int j=0;
        for (; j < word[i].length(); j++) {
            if (!chk[word[i][j]-'a'])
                break;
        }
        if (j == word[i].length())
            cnt++;
    }

    return cnt;
}
void combination(int idx, int start,int end) {//제외할 단어들을 추출
    if (start == end) {
        answer = max(answer, canRead());
        return;
    }
    for (int i = idx; i<26;i++) {

        if (chk[i])
            continue;
        chk[i] = true;
        combination(i, start+1,end);
        chk[i] = false;

    }


}


int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, k;
    cin >> n >> k;
    if (k < 5) {
        cout << 0 << '\n';
        return 0;
    }
    chk['a' - 'a'] = true;
    chk['n' - 'a'] = true;
    chk['t' - 'a'] = true;
    chk['i' - 'a'] = true;
    chk['c' - 'a'] = true;
    for (int i = 0; i < n; i++) {
        string str;
        cin >> str;
        int count = str.length() - 8;
        str = str.substr(4, count); //접두사와 접미사를 자른다.
        string str_cut = "";
        for (auto o : str) {
            if (!chk[o-'a']) {//antic가아니면
                str_cut += o;
            }
        }
        word.push_back(str_cut);
    }
    combination(0,0,k-5);
    cout << answer;
    return 0;
}

코드2(Hash)-시간 초과 및 오답

#include <iostream>
#include <vector>
#include <queue>
#include <string>
#include <set>
#include <map>

using namespace std;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, k,answer=0;
    cin >> n >> k;
    if (k < 5) {
        cout << 0 << '\n';
        return 0;
    }

    vector<string> vt;
    set<char> basic;
    basic.insert('a');
    basic.insert('n');
    basic.insert('t');
    basic.insert('i');
    basic.insert('c');
    map<char,int> ma;
    vector<set<char>> se_vt;
    for (int i = 0; i < n; i++) {
        string str;
        cin >> str;
        int count = str.length() - 8;
        str = str.substr(4, count);
        vt.push_back(str);
        set<char> se;
        for (auto o : str) {//한 문자열의 단어 중복을 없애기
            if (basic.count(o) == 0) {//antic가아니면
                se.insert(o);
            }
        }
        se_vt.push_back(se);
        for (auto o : se) {//전체 단어 개수 카운팅
            ma[o]++;
        }
    }
    map<char, int>::iterator it = --ma.end();
    set<char> ma_set;

    while (k - basic.size()) {
        ma_set.insert((*it).first);
        it--;
        k--;
    }
        for (int i = 0; i < vt.size(); i++) {
            int count = 0;
            for (auto o : se_vt[i]) {
                if (ma_set.count(o) != 0)
                    count++;
            }
            if (count == se_vt[i].size())
                answer++;
        }
        cout << answer << '\n';
    return 0;
}

코드2(조합/DFS)-코틀린

import kotlin.math.*
val br = System.`in`.bufferedReader()

//1<=n<=50
//0<=k<26
val chk = BooleanArray(26)
var answer=0

fun count(words : Array<String>, n : Int) : Int{
    var cnt=0
    for(i in 0 until n){
        var j=4
        while(j<words[i].length-3){
            if(!chk[words[i][j++]-'a'])break
        }
        if(j==words[i].length-3) cnt++
    }
    return cnt
}

fun combination(idx : Int, cnt : Int, n : Int, k : Int, words : Array<String>){

    if(cnt==k){
        answer = max(answer,count(words,n))
        return
    }

    for(i in idx until 26){
        if(chk[i])continue
        chk[i]=true
        combination(i+1,cnt+1,n,k,words)
        chk[i]=false
    }
}

fun main() = with(System.out.bufferedWriter()){
    val (n,k) = br.readLine().split(' ').map{it.toInt()}
    val words = Array(n){br.readLine()}
    chk[0]=true
    chk['i'-'a']=true
    chk['n'-'a']=true
    chk['t'-'a']=true
    chk['c'-'a']=true

    if(k<5){
        write("0")
    }
    else{
        combination(0,0,n,k-5,words)
        write("$answer")
    }
    close()
}
반응형

댓글